/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2012 University of Bonn. All rights reserved.
 * 
 *
 *   This file is part of MoleCuilder.
 *
 *    MoleCuilder is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MoleCuilder is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * VectorPositiveComponentsValidator.cpp
 *
 *  Created on: May 10, 2012
 *      Author: ankele
 */


// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

//#include "CodePatterns/MemDebug.hpp"

#include "VectorPositiveComponentsValidator.hpp"

#include "LinearAlgebra/RealSpaceMatrix.hpp"

bool VectorPositiveComponentsValidator::isValid(const Vector & _value) const
{
  bool status = true;
  for (size_t i=0;i<NDIM;++i)
    status = status && (_value[i] > 0);
  return status;
}

bool VectorPositiveComponentsValidator::operator==(const Validator<Vector> &_instance) const
{
  const VectorPositiveComponentsValidator *inst =
      dynamic_cast<const VectorPositiveComponentsValidator *>(&_instance);
  if (inst)
    return true;
  else
    return false;
}

Validator< Vector >* VectorPositiveComponentsValidator::clone() const
{
  Validator< Vector > *inst =
      new VectorPositiveComponentsValidator();
  return inst;
}




